// Copyright (c) 2010, SoftLayer Technologies, Inc. All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are met:
//
//  * Redistributions of source code must retain the above copyright notice,
//    this list of conditions and the following disclaimer.
//  * Redistributions in binary form must reproduce the above copyright notice,
//    this list of conditions and the following disclaimer in the documentation
//    and/or other materials provided with the distribution.
//  * Neither SoftLayer Technologies, Inc. nor the names of its contributors may
//    be used to endorse or promote products derived from this software without
//    specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
// AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
// IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
// ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
// LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
// CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
// SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
// INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
// CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
// ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.

Date.dateFromISO8601 = function (string)
{    
    var dateExpression = /([0-9]{4})-([0-9]{1,2})-([0-9]{1,2})T([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})([-+][0-9]{1,2}):([0-9]{1,2})/i;
    var matchData = string.match(dateExpression);

    var newDate = new Date();
    newDate.setUTCFullYear(parseInt(matchData[1]), parseInt(matchData[2]) - 1, parseInt(matchData[3]));
    
    var hour = parseInt(matchData[4]) + parseInt(matchData[7]);
    while(hour < 0)
    {
        hour += 12;
    }

    newDate.setUTCHours(parseInt(matchData[4]) - parseInt(matchData[7]), parseInt(matchData[5]), parseInt(matchData[6]));
                    
    return newDate;
}

Date.prototype.formattedShortDate = function ()
{
    var meridian = "AM"
    
    var hours = this.getHours()
    if(this.getHours() > 12)
    {
        hours = hours - 12
        meridian = "PM"
    }

    if(hours == 0)
    {
        hours = 12
    }

    if(hours < 10)
    {
        hours = "0" + hours
    } else {
        hours = hours.toString()
    }
    
    var minutes = this.getMinutes()
    if(minutes < 10)
    {
        minutes = "0" + minutes
    } else {
        minutes = minutes.toString()
    }

    return "" + (this.getMonth() + 1) + "/" + (this.getDate()) + "/" + this.getFullYear() + " " + hours + ":" + minutes + " " + meridian;
}